"use strict";
import { getFSAFromEventArgs } from "../Utils/Common";
import { readModel as factoryReadModel, reducer as factoryReducer } from "./Reducer";
import { Permissions } from "../Permissions/Permissions";
export class Factory extends Permissions {
    constructor(framework) {
        super(framework);
        this.framework = framework;
        this.createEventStore = async (factory, fromAddress) => {
            let tx = await factory.createEventStore({
                from: fromAddress,
                gas: 4000000
            });
            let fsa = getFSAFromEventArgs(tx.logs[0].args);
            return {
                events: [fsa],
                tx: tx
            };
        };
        this.getAllEventStoreContractAddresses = async (factory, fromAddress) => {
            let addresses = await factory.getEventStores({
                from: fromAddress
            });
            return addresses;
        };
        this.getFactoryReadModel = async (factory, fromAddress) => {
            return this.framework.ReadModel.getCachedReadModel(factory, fromAddress, factoryReadModel, factoryReducer);
        };
    }
}
//# sourceMappingURL=Factory.js.map